#ifndef TYPENAME_H
#define TYPENAME_H

#include <frost_utils.h>

namespace Frost
{

class Module;
class Class;

struct TypeName
{
    s_str            sType;
    s_str            sFullType;
    s_str            sFullNakedType;
    s_str            sNakedType;
    s_str            sNestedType;
    s_str            sNamespace;
    s_ctnr<s_str>    lNamespaces;
    s_str            sMembership;
    s_ctnr<s_str>    lMemberships;
    s_str            sTemplateParams;
    s_ctnr<TypeName> lTemplateParams;

    s_bool bIsPointer;
    s_bool bIsTemplate;
    s_bool bIsTemplateParam;
    s_bool bIsTypedef;
    s_bool bIsEnum;
    s_bool bIsPrivate;
    s_bool bIsProtected;

    s_bool       bIsNested;
    s_ptr<Class> pOwner;

    s_ctnr<s_str> lQualifiers;

    s_wptr<Class>  pClass;
    s_wptr<Module> pModule;

    s_bool operator == (const TypeName& mName) const
    {
        return sFullType == mName.sFullType;
    }

    s_bool TryDecorateType(const TypeName& mRef, TypeName& mType, s_wptr<Module> pModule, const s_ctnr<s_str>& lContext) const;
    s_str  Qualify();
};

template<> class StringConverter<string_element, TypeName>
{
public :

    typedef s_str::string string;

    static string Convert(const TypeName& mType);
};

}

#endif // TYPENAME_H
