#include "inputsource.h"

using namespace Frost;

s_bool InputSource::IsValid() const
{
    return mImpl_->IsValid();
}

char InputSource::Get()
{
    if (lIgnoredList_.IsEmpty())
        return mImpl_->Get();

    char c;

    do
    {
        c = mImpl_->Get();
    }
    while (mImpl_->IsValid() && lIgnoredList_.Find(c));

    return c;
}

void InputSource::Ignore(const char& c)
{
    lIgnoredList_.PushBack(c);
}

InputSourceBase::InputSourceBase()
{
}

InputSourceBase::~InputSourceBase()
{
}

Source<File>::Source(File& mFile) : mFile_(mFile)
{
}

s_bool Source<File>::IsValid() const
{
    return mFile_.IsValid();
}

char Source<File>::Get()
{
    return mFile_.Get();
}

Source<s_str>::Source(const s_str& sString) : sString_(sString)
{
}

s_bool Source<s_str>::IsValid() const
{
    return (uiPos_ != sString_.GetSize());
}

char Source<s_str>::Get()
{
    return sString_[uiPos_++];
}
